      subroutine readpdb
C Read the PDB file and convert the peptide geometry into virtual-chain 
C geometry.
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.LOCAL'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.NAMES'
      include 'COMMON.CONTROL'
      include 'COMMON.DISTFIT'
      include 'COMMON.SETUP'

c      integer dziura_beg(99), dziura_end(99), ilosc_dziur

      integer i,j,ibeg,ishift1,ires,iii,ires_old,ishift,ity,
     &  ishift_pdb, ijr, ires_beg, ires_old2, idodatek
      logical lprn /.true./,fail
      double precision e1(3),e2(3),e3(3)
      double precision dcj,efree_temp
      character*3 seq,res
      character*5 atom
      character*80 card
      double precision sccor(3,20)
      integer rescode

c      write (iout,*) "TESTOWE2: CZYTAM PDBAa"
      ilosc_dziur=0

      efree_temp=0.0d0
      ibeg=1
      ibeg1=1
      idodatek=0
      ishift1=0
      ishift=0
c      write (2,*) "UNRES_PDB",unres_pdb
      ires=0
      ires_old=0

      ires_beg=999
      ires_old2=99999
      ijr=0

      iii=0
      lsecondary=.false.
      nhfrag=0
      nbfrag=0
c      write(iout,*)"TESTOWE: I'm trying to read the pdb"
      do i=1,900000
c      write(iout,*)"TESTOWE: I'm trying to read the pdb line:", i
        read (ipdbin,'(a80)',end=10) card
c        write (iout,'(a)') card
c        if (card(:5).eq.'HELIX') then
c         nhfrag=nhfrag+1
c         lsecondary=.true.
c         read(card(22:25),*) hfrag(1,nhfrag)
c         read(card(34:37),*) hfrag(2,nhfrag)
c        endif
c        if (card(:5).eq.'SHEET') then
c         nbfrag=nbfrag+1
c         lsecondary=.true.
c         read(card(24:26),*) bfrag(1,nbfrag)
c         read(card(35:37),*) bfrag(2,nbfrag)
crc----------------------------------------
crc  to be corrected !!!
c         bfrag(3,nbfrag)=bfrag(1,nbfrag)
c         bfrag(4,nbfrag)=bfrag(2,nbfrag)
crc----------------------------------------
c        endif
        if (card(:3).eq.'END'.or.card(:3).eq.'TER'.and.ibeg1.ne.1)
     &      goto 10
c Read free energy
c        if (index(card,"FREE ENERGY").gt.0) read(card(35:),*) efree_temp
C Fish out the ATOM cards.
        if (index(card(1:4),'ATOM').gt.0) then  

c          write(iout,*)"TESTOWE: czytam1", i, card(14:15)
          if (card(14:15).ne.'CA'.and.card(14:15).ne.'N '.and.ibeg.eq.1
     & .and.ibeg1.eq.1) cycle
c          write(iout,*)"TESTOWE: czytam2", i
          read (card(12:16),*) atom

          ibeg1=0

          read (card(23:26),*) ires
          if (ibeg.eq.1.and.ires.le.0) idodatek=ABS(0-ires)+1
          if (ibeg.eq.1.and.ires.gt.1) idodatek=(0-ires)+1
          ires=ires+idodatek
c          write(iout,*) ires, res

c          if (ijr.eq.0) then
c             ires_beg=ires
c             ijr=1
c          endif

          read (card(18:20),'(a3)') res
c          write (iout,*) "TESTOWE:", atom, ires
c        if (ires.ne.(ires_old+ires_beg-1)) write (iout,*) 
c     &     "TESTOWE:", "DZIURA",
c     &     ires, ires_old, ires_beg
c          write (iout,*) "ires",ires,ires-ishift+ishift1,
c     &      " ires_old",ires_old
c          write (iout,*) "ishift",ishift," ishift1",ishift1
c          write (iout,*) "IRES",ires-ishift+ishift1,ires_old
          if (ires-ishift+ishift1.ne.ires_old) then
C Calculate the CM of the preceding residue.
c            if (ibeg.eq.0) call sccenter(ires,iii,sccor)
            if (ibeg.eq.0) then
c              write (iout,*) "Calculating sidechain center iii",iii
              if (unres_pdb) then
                do j=1,3
                  dc(j,ires)=sccor(j,iii)
                enddo
              else
                call sccenter(ires_old,iii,sccor)
              endif
              iii=0
            endif
C Start new residue.
            if (res.eq.'Cl-' .or. res.eq.'Na+') then
              ires=ires_old
              cycle
            else if (ibeg.eq.1) then
c              write (iout,*) "BEG ires",ires
c             write(iout,*) "TESTOWE: ishift=ires-1"
             ishift=ires-1
              if (res.ne.'GLY' .and. res.ne. 'ACE') then
c             write(iout,*) "TESTOWE: Gly ishift=ires-1"
                ishift=ishift-1
                itype(1)=21
              endif
              ires=ires-ishift+ishift1
              ires_old=ires
c              write (iout,*) "ishift",ishift," ires",ires,
c     &         " ires_old",ires_old
              ibeg=0          
            else
c             write(iout,*) "TESTOWE: ishift=ishift-(ires-ishift+is..."

c ZMIANA DO DZIUR!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
c              ishift=ishift-(ires-ishift+ishift1-ires_old-1)
c ZMIANA DO DZIUR!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

              ires=ires-ishift+ishift1
              ires_old=ires
            endif
            if (res.eq.'ACE' .or. res.eq.'NHE') then
              itype(ires)=10
            else
              itype(ires)=rescode(ires,res,0)
            endif
          else
            ires=ires-ishift+ishift1
          endif
c          write (iout,*) "ires_old",ires_old," ires",ires
          if (card(27:27).eq."A" .or. card(27:27).eq."B") then
c            ishift1=ishift1+1
          endif
c          write (2,*) "ires",ires," res ",res," ity",ity
          if (atom.eq.'CA' .or. atom.eq.'CH3' .or. 
     &       res.eq.'NHE'.and.atom(:2).eq.'HN') then
            read(card(31:54),'(3f8.3)') (c(j,ires),j=1,3)


c          if (ijr.eq.0) then
c             ires_beg=ires
c             ijr=1
c          endif


        if (ires_old2.eq.99999) ires_old2=ires-1
c           write (iout,*) "TESTOWE:", atom, ires, res
        if (ires.ne.(ires_old2+1)) then
           ijr=ijr+1
           dziura_beg(ijr)=ires_old2
           dziura_end(ijr)=ires
           ilosc_dziur=ijr
           write (iout,*) "TESTOWE:", "DZIURA", ires, res, ires_old2,
     &     dziura_beg(ijr), dziura_end(ijr), ilosc_dziur, ijr
        endif
        ires_total=ires

        ires_old2=ires

c            write (iout,*) "backbone ",atom 
#ifdef DEBUG
            write (iout,'(2i3,2x,a,3f8.3)') 
     &      ires,itype(ires),res,(c(j,ires),j=1,3)
#endif
            iii=iii+1
            do j=1,3
              sccor(j,iii)=c(j,ires)
            enddo
            if (ishift.ne.0) then
              ires_ca=ires+ishift-ishift1
            else
              ires_ca=ires
            endif
c            write (*,*) card(23:27),ires,itype(ires)
          else if (atom.ne.'O'.and.atom(1:1).ne.'H' .and.
     &             atom.ne.'N' .and. atom.ne.'C' .and.
     &             atom(:2).ne.'1H' .and. atom(:2).ne.'2H' .and.
     &             atom.ne.'OXT' .and. atom(:2).ne.'3H') then
c            write (iout,*) "sidechain ",atom
            iii=iii+1
            read(card(31:54),'(3f8.3)') (sccor(j,iii),j=1,3)
          endif
        endif
      enddo
   10 continue
c      write (iout,*) "ires:", ires
c      ires=ires-1
      write (iout,'(a,i5)') ' Number of residues found: ',ires
      if (ires.eq.0) return
C Calculate the CM of the last side chain.
      if (iii.gt.0)  then
      if (unres_pdb) then
        do j=1,3
          dc(j,ires)=sccor(j,iii)
        enddo
      else
        call sccenter(ires,iii,sccor)
      endif
      endif
      nres=ires
c      write (iout,*) "nres:", nres
      nsup=nres
      nstart_sup=1

c      if (itype(nres).eq.0) itype(nres)=12

      if (itype(nres).ne.10) then
        nres=nres+1
        itype(nres)=21
        do j=1,3
          dcj=c(j,nres-2)-c(j,nres-3)
          c(j,nres)=c(j,nres-1)+dcj
          c(j,2*nres)=c(j,nres)
        enddo
      endif
c      write (iout,*) "nres:", nres
      do i=2,nres-1
        do j=1,3
          c(j,i+nres)=dc(j,i)
        enddo
      enddo
      do j=1,3
        c(j,nres+1)=c(j,1)
        c(j,2*nres)=c(j,nres)
      enddo
      if (itype(1).eq.21) then
        nsup=nsup-1
        nstart_sup=2
        if (unres_pdb) then
C 2/15/2013 by Adam: corrected insertion of the first dummy residue
          call refsys(2,3,4,e1,e2,e3,fail)
          if (fail) then
            e2(1)=0.0d0
            e2(2)=1.0d0
            e2(3)=0.0d0
          endif
          do j=1,3
            c(j,1)=c(j,2)-3.8d0*e2(j)
          enddo
        else
        do j=1,3
          dcj=c(j,4)-c(j,3)
          c(j,1)=c(j,2)-dcj
          c(j,nres+1)=c(j,1)
        enddo
        endif
      endif
C Copy the coordinates to reference coordinates
c      do i=1,2*nres
c        do j=1,3
c          cref(j,i)=c(j,i)
c        enddo
c      enddo
C Calculate internal coordinates.
      if (lprn) then
      write (iout,'(/a)') 
     &  "Cartesian coordinates of the reference structure"
      write (iout,'(a,3(3x,a5),5x,3(3x,a5))') 
     & "Residue","X(CA)","Y(CA)","Z(CA)","X(SC)","Y(SC)","Z(SC)"
      do ires=1,nres

c MODYFIKACJA
        if (itype(ires).eq.0) itype(ires)=11

        write (iout,'(a3,1x,i3,3f8.3,5x,3f8.3)') 
     &    restyp(itype(ires)),ires,(c(j,ires),j=1,3),
     &    (c(j,ires+nres),j=1,3)
      enddo
      endif
C Calculate internal coordinates.
      if(me.eq.king.or..not.out1file)then
       write (iout,'(a)') 
     &   "Backbone and SC coordinates as read from the PDB"
       do ires=1,nres
        write (iout,'(2i3,2x,a,3f8.3,5x,3f8.3)') 
     &    ires,itype(ires),restyp(itype(ires)),(c(j,ires),j=1,3),
     &    (c(j,nres+ires),j=1,3)
       enddo
      endif
      call int_from_cart(.true.,.false.)
      call sc_loc_geom(.false.)
      do i=1,nres
        thetaref(i)=theta(i)
        phiref(i)=phi(i)
      enddo
      do i=1,nres-1
        do j=1,3
          dc(j,i)=c(j,i+1)-c(j,i)
          dc_norm(j,i)=dc(j,i)*vbld_inv(i+1)
        enddo
      enddo
      do i=2,nres-1
        do j=1,3
          dc(j,i+nres)=c(j,i+nres)-c(j,i)
          dc_norm(j,i+nres)=dc(j,i+nres)*vbld_inv(i+nres)
        enddo
c        write (iout,*) i,(dc(j,i+nres),j=1,3),(dc_norm(j,i+nres),j=1,3),
c     &   vbld_inv(i+nres)
      enddo
c      call chainbuild
C Copy the coordinates to reference coordinates
      do i=1,2*nres
        do j=1,3
          cref(j,i)=c(j,i)
        enddo
      enddo

      write(iout,*) "TESTOWE: nres in end of pdbread", nres

      do j=1,nbfrag     
        do i=1,4                                                       
         bfrag(i,j)=bfrag(i,j)-ishift
        enddo
      enddo

      do j=1,nhfrag
        do i=1,2
         hfrag(i,j)=hfrag(i,j)-ishift
        enddo
      enddo
      ishift_pdb=ishift
      return
      end
c---------------------------------------------------------------------------
      subroutine int_from_cart(lside,lprn)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
#ifdef MPI
      include "mpif.h"
#endif
      include 'COMMON.LOCAL'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.NAMES'
      include 'COMMON.CONTROL'
      include 'COMMON.SETUP'
      character*3 seq,res
c      character*5 atom
      character*80 card
      dimension sccor(3,20)
      integer rescode
      logical lside,lprn
      if(me.eq.king.or..not.out1file)then
       if (lprn) then 
        write (iout,'(/a)') 
     &  'Internal coordinates calculated from crystal structure.'
        if (lside) then 
          write (iout,'(8a)') '  Res  ','       dvb','     Theta',
     & '     Gamma','    Dsc_id','       Dsc','     Alpha',
     & '     Beta '
        else 
          write (iout,'(4a)') '  Res  ','       dvb','     Theta',
     & '     Gamma'
        endif
       endif
      endif
      do i=1,nres-2
        iti=itype(i)
c        if (dist(i,i+1).lt.2.0D0 .or. dist(i,i+1).gt.5.0D0) then
c ZMORA MODYFIKACJA!
        if (dist(i,i+1).lt.2.0D0 .or. dist(i,i+1).gt.5.5D0) then
          write (iout,*) 'Bad Cartesians for residue',i,
     &           "Nres", nres, "Distance:", dist(i,i+1)
c           ijr=ijr+1
c           dziura_beg(ijr)=i
c           dziura_end(ijr)=i+1
c           ilosc_dziur=ilosc_dziur+1
c          write (iout,*) "DZIURA!:", ijr, ilosc_dziur

ctest          stop
        endif
        vbld(i+1)=dist(i,i+1)
        vbld_inv(i+1)=1.0d0/vbld(i+1)
        if (i.gt.1) theta(i+1)=alpha(i-1,i,i+1)
        if (i.gt.2) phi(i+1)=beta(i-2,i-1,i,i+1)
      enddo
c      if (unres_pdb) then
c        if (itype(1).eq.21) then
c          theta(3)=90.0d0*deg2rad
c          phi(4)=180.0d0*deg2rad
c          vbld(2)=3.8d0
c          vbld_inv(2)=1.0d0/vbld(2)
c        endif
c        if (itype(nres).eq.21) then
c          theta(nres)=90.0d0*deg2rad
c          phi(nres)=180.0d0*deg2rad
c          vbld(nres)=3.8d0
c          vbld_inv(nres)=1.0d0/vbld(2)
c        endif
c      endif
      if (lside) then
        do i=2,nres-1
          do j=1,3
            c(j,maxres2)=0.5D0*(2*c(j,i)+(c(j,i-1)-c(j,i))*vbld_inv(i)
     &     +(c(j,i+1)-c(j,i))*vbld_inv(i+1))
          enddo
          iti=itype(i)
          di=dist(i,nres+i)
C 10/03/12 Adam: Correction for zero SC-SC bond length
          if (itype(i).ne.10 .and. itype(i).ne.21. and. di.eq.0.0d0)
     &     di=dsc(itype(i))
          vbld(i+nres)=di
          if (itype(i).ne.10) then
            vbld_inv(i+nres)=1.0d0/di
          else
            vbld_inv(i+nres)=0.0d0
          endif
          if (iti.ne.10) then
            alph(i)=alpha(nres+i,i,maxres2)
            omeg(i)=beta(nres+i,i,maxres2,i+1)
            if (alph(i).eq.0.and.i.gt.2) then 
             write(iout,*)"alph(i)=0, missing side chain for residue:",i
             alph(i)=1.0
             omeg(i)=2.0
c             if (i.eq.2) then
c                  nstart_sup=nstart_sup+1
c                  write(iout,*) "TESTOWE: nstart_sup=",nstart_sup
c             endif
             ijr=ilosc_dziur+1
             dziura_beg(ijr)=i
             dziura_end(ijr)=i
             ilosc_dziur=ijr
             write (iout,*) "TESTOWE:", "DZIURA",
     &       dziura_beg(ijr), dziura_end(ijr), ilosc_dziur, ijr
            endif

c            if (omeg(i).eq.180) write(iout,*) "TESTOWE: omeg(i)=180", i
          endif
          if(me.eq.king.or..not.out1file)then
           if (lprn)
     &     write (iout,'(a3,i4,7f10.3)') restyp(iti),i,vbld(i),
     &     rad2deg*theta(i),rad2deg*phi(i),dsc(iti),vbld(nres+i),
     &     rad2deg*alph(i),rad2deg*omeg(i)
          endif
        enddo
      else if (lprn) then
        do i=2,nres
          iti=itype(i)
          if(me.eq.king.or..not.out1file)
     &     write (iout,'(a3,i4,7f10.3)') restyp(iti),i,dist(i,i-1),
     &     rad2deg*theta(i),rad2deg*phi(i)
        enddo
      endif
      return
      end
c-------------------------------------------------------------------------------
      subroutine sc_loc_geom(lprn)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
#ifdef MPI
      include "mpif.h"
#endif
      include 'COMMON.LOCAL'
      include 'COMMON.VAR'
      include 'COMMON.CHAIN'
      include 'COMMON.INTERACT'
      include 'COMMON.IOUNITS'
      include 'COMMON.GEO'
      include 'COMMON.NAMES'
      include 'COMMON.CONTROL'
      include 'COMMON.SETUP'
      double precision x_prime(3),y_prime(3),z_prime(3)
      logical lprn
      do i=1,nres-1
        do j=1,3
          dc_norm(j,i)=vbld_inv(i+1)*(c(j,i+1)-c(j,i))
        enddo
      enddo
      do i=2,nres-1
        if (itype(i).ne.10) then
          do j=1,3
            dc_norm(j,i+nres)=vbld_inv(i+nres)*(c(j,i+nres)-c(j,i))
          enddo
        else
          do j=1,3
            dc_norm(j,i+nres)=0.0d0
          enddo
        endif
      enddo
      do i=2,nres-1
        costtab(i+1) =dcos(theta(i+1))
        sinttab(i+1) =dsqrt(1-costtab(i+1)*costtab(i+1))
        cost2tab(i+1)=dsqrt(0.5d0*(1.0d0+costtab(i+1)))
        sint2tab(i+1)=dsqrt(0.5d0*(1.0d0-costtab(i+1)))
        cosfac2=0.5d0/(1.0d0+costtab(i+1))
        cosfac=dsqrt(cosfac2)
        sinfac2=0.5d0/(1.0d0-costtab(i+1))
        sinfac=dsqrt(sinfac2)
        it=itype(i)
        if (it.ne.10) then
c
C  Compute the axes of tghe local cartesian coordinates system; store in
c   x_prime, y_prime and z_prime 
c
        do j=1,3
          x_prime(j) = 0.00
          y_prime(j) = 0.00
          z_prime(j) = 0.00
        enddo
        do j = 1,3
          x_prime(j) = (dc_norm(j,i) - dc_norm(j,i-1))*cosfac
          y_prime(j) = (dc_norm(j,i) + dc_norm(j,i-1))*sinfac
        enddo
        call vecpr(x_prime,y_prime,z_prime)
c
C Transform the unit vector of the ith side-chain centroid, dC_norm(*,i),
C to local coordinate system. Store in xx, yy, zz.
c
        xx=0.0d0
        yy=0.0d0
        zz=0.0d0
        do j = 1,3
          xx = xx + x_prime(j)*dc_norm(j,i+nres)
          yy = yy + y_prime(j)*dc_norm(j,i+nres)
          zz = zz + z_prime(j)*dc_norm(j,i+nres)
        enddo

        xxref(i)=xx
        yyref(i)=yy
        zzref(i)=zz
        else
        xxref(i)=0.0d0
        yyref(i)=0.0d0
        zzref(i)=0.0d0
        endif
      enddo
      if (lprn) then
        do i=2,nres
          iti=itype(i)
          if(me.eq.king.or..not.out1file)
     &     write (iout,'(a3,i4,3f10.5)') restyp(iti),i,xxref(i),
     &      yyref(i),zzref(i)
        enddo
      endif
      return
      end
c---------------------------------------------------------------------------
      subroutine sccenter(ires,nscat,sccor)
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.CHAIN'
      dimension sccor(3,20)
      do j=1,3
        sccmj=0.0D0
        do i=1,nscat
          sccmj=sccmj+sccor(j,i) 
        enddo
        dc(j,ires)=sccmj/nscat
      enddo
      return
      end
c---------------------------------------------------------------------------
      subroutine bond_regular
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'   
      include 'COMMON.VAR'
      include 'COMMON.LOCAL'      
      include 'COMMON.CALC'
      include 'COMMON.INTERACT'
      include 'COMMON.CHAIN'
      do i=1,nres-1
       vbld(i+1)=vbl
       vbld_inv(i+1)=1.0d0/vbld(i+1)
       vbld(i+1+nres)=dsc(itype(i+1))
       vbld_inv(i+1+nres)=dsc_inv(itype(i+1))
c       print *,vbld(i+1),vbld(i+1+nres)
      enddo
      return
      end
